import googsystray
import gtk,gobject
import calendar
import threading
import copy
import time

from xml.dom import minidom
from xml.etree import ElementTree as ET
from GIcon import GIcon			
import GMain


class GCal(GIcon):
	def draw_message(self, message):
		mvbox = self.popup_window.vbox
		
		vbox = gtk.VBox()
		mvbox.pack_start(vbox, False, False, 0)
		vbox.set_data("msg_id", message["id"])
		self.popup_messages.append(vbox)
		
		event = message["data"]

		frame = gtk.Frame()
		vbox1 = gtk.VBox()
		frame.add(vbox1)
		vbox.pack_end(frame, False, False, 3)

		hbox = gtk.HBox()
		label = gtk.Label()
		label.set_markup("<b>" + event["title"] + "</b>")
		hbox.pack_start(label, False, False, 5)
		label = gtk.Label(time.strftime("%c", time.localtime(event["startTime"])))
		hbox.pack_end(label, False, False, 5)
		vbox1.pack_start(hbox, False, False, 5)


		hbox = gtk.HBox()
		label = gtk.Label()
		label.set_markup("<b>" + _("Where:") + "</b>")
		hbox.pack_start(label, False, False, 5)
		if event["where"] is None:
			label = gtk.Label()
			label.set_markup("<i>" + _("No location provided") + "</i>")
		else:
			label = gtk.Label()
			label.set_markup(event["where"])
		hbox.pack_start(label, False, False, 5)
		vbox1.pack_start(hbox, False, False, 0)

		hbox = gtk.HBox()
		label = gtk.Label()
		label.set_markup("<b>" + _("Description:") + "</b>")
		hbox.pack_start(label, False, False, 5)
		if event["content"] is None:
			label = gtk.Label()
			label.set_markup("<i>" + _("No description provided") + "</i>")
		else:
			label = gtk.Label()
			label.set_markup(event["content"])
		hbox.pack_start(label, False, False, 5)
		vbox1.pack_start(hbox, False, False, 0)
		

	def dumpit(self, node, depth=0):
		for i in range(depth):
			print "\t",
		print "<" + node.tag.encode("utf-8"),
		for i in node.attrib:
			print " " + i + " = \"" + node.attrib[i].encode("utf-8") + "\"",
		print ">",
		if node.text != None:
			print node.text.encode("utf-8")
		else:
			print ""
		
		for i in node.getchildren():
			self.dumpit(i, depth+1)
	


	def checkEvents(self, account, cal, feedurl):
		sttime = time.gmtime()
		# We'll get a weeks worth of events.  
		endtime = time.gmtime(time.time() + (3600*24*7))
		
		req_times=time.strftime("&start-min=%Y-%m-%dT%H:%M:00-00:00", sttime)
		req_times+=time.strftime("&start-max=%Y-%m-%dT%H:%M:00-00:00", endtime)
		req_times+=time.strftime("&recurrence-expansion-start=%Y-%m-%dT%H:%M:00-00:00", sttime)
		req_times+=time.strftime("&recurrence-expansion-end=%Y-%m-%dT%H:%M:00-00:00", endtime)
		
		headers = {"Authorization" : self.auth[account["name"]] }

		data = self.urlopen2(account, feedurl+"?ctz=UTC&singleevents=true" + req_times, headers=headers)
		if data == None:
			return True		
		node = ET.XML(data)
		
		title = node.find("{http://www.w3.org/2005/Atom}title").text

		for e in node.findall("{http://www.w3.org/2005/Atom}entry"):
			id = e.find("{http://www.w3.org/2005/Atom}id").text

			upd = e.find("{http://www.w3.org/2005/Atom}updated")
			tmpstr = upd.text[:-5] + " UTC"
			updtime = calendar.timegm(time.strptime(tmpstr, "%Y-%m-%dT%H:%M:%S %Z"))

			if cal["entries"].get(id) != None:
				if cal["entries"][id]["updated_time"] < updtime:
					del cal["entries"][id]

			when = e.find("{http://schemas.google.com/g/2005}when")
			# fixme these are, I believe, events that cover a whole day, like a holiday. 
			# once we start doing real calendar support, we'll need these.
			if (when == None):
				continue
				
			# fixme also these :)
			if (when.find("{http://schemas.google.com/g/2005}reminder") == None):
				continue
				
			eventTitle = e.find("{http://www.w3.org/2005/Atom}title").text
			eventContent = e.find("{http://www.w3.org/2005/Atom}content").text
			where = e.find("{http://schemas.google.com/g/2005}where")
			if where.get("valueString") != None:
				eventWhere = where.attrib["valueString"]
			else:
				eventWhere = None

			startTime = when.attrib["startTime"]
			if (len(startTime) == 10):
				startTime += "T00:00:00 UTC"
			else:
				startTime = startTime[:-5] + " UTC"

			stTime = calendar.timegm(time.strptime(startTime, "%Y-%m-%dT%H:%M:%S %Z"))
			
			# No reason to worry about past events.
			if (stTime < time.time()):
				continue


			cal["entries"][id] = { "title" : eventTitle, 
							 "updated_time" : updtime,
							 "content" : eventContent,
							 "where" : eventWhere,
							 "startTime" : stTime,
							 "reminders": [] }
			
			for r in when.findall("{http://schemas.google.com/g/2005}reminder"):
				if (r.attrib["method"] == "alert"):
					cal["entries"][id]["reminders"].append({"alertTime": stTime-int(r.attrib["minutes"])*60,
												  "hasReminded":False,"isActive":False})
		
		
	 
	def icon_check_data(self, account):
		if account["name"] not in self.auth or self.auth[account["name"]] == None:
			self.get_auth(account, 'cl')
			
		headers = {"Authorization" : self.auth[account["name"]] }
		data = self.urlopen2(account, 'https://www.google.com/calendar/feeds/default/', headers=headers)
		
		if data == None:
			return True
		node = ET.XML(data)
		
		self.cal_lock.acquire()
		
		for e in node.findall("{http://www.w3.org/2005/Atom}entry"):
			title = e.find("{http://www.w3.org/2005/Atom}title").text
			cal = None
			for i in self.calendars:
				if i["title"] == title and i["account"] == account["name"]:
					cal = i
					break
			if cal is None:
				cal = { "title": title, "account": account["name"], "last_checked" : 0, "last_updated" : 0, "entries" : {} }
				self.calendars.append(cal)

		
			upd = e.find("{http://www.w3.org/2005/Atom}updated")
			tmpstr = upd.text[:-5] + " UTC"
			updtime = calendar.timegm(time.strptime(tmpstr, "%Y-%m-%dT%H:%M:%S %Z"))
			
			# Check once a day whether we need to or not -- this is important because
			# we only get a weeks worth of stuff.  I suppose we could do this less often
			
			if updtime > cal["last_updated"] or time.time() > (cal["last_checked"] + (3600*24)):
				cal["last_checked"] = time.time()
				cal["last_updated"] = updtime
				c = e.find("{http://www.w3.org/2005/Atom}content")
				self.checkEvents(account, cal, c.attrib["src"])
				
		
		self.cal_lock.release()
		
		gobject.idle_add(self.check_calendar_once, None)
		return True
		
	def check_calendar_once(self, data=None):
		self.check_calendar(data)

	def check_calendar(self,data=None):
		if not self.am_used():
			return False
			
		# Make sure we get the calendars list OK
		if not self.cal_lock.acquire(0):
			return True
		new_messages = []		

		for i in self.calendars:
			if (i["entries"] == None):
				continue
			for e in i["entries"].items():
				for r in e[1]["reminders"]:
					if r["alertTime"] < time.time() and e[1]["startTime"] > time.time():
						new_messages.append(
							{ "id": e[0],
							  "sub_id": "reminder",
							  "account": i["account"],
							  "count": 1,
							  "title": "Calendar Reminder",
							  "summary": "Whatever",
							  "icon": None,
							  "marked": False,
							  "data": copy.deepcopy(e[1]),
							  })
						break;

		self.cal_lock.release()	
		while not self.thread_lock.acquire(0):
			if not self.thread_run:
				return True
			time.sleep(0.1)
		self.messages_unread = new_messages
		gobject.idle_add(self.update_icon, None)
		self.thread_lock.release()

		
		return True
		
	def icon_stop(self):
		if self.cal_check_timer != -1:
			gobject.source_remove(self.cal_check_timer)
		return
		
	def icon_start (self):
		if not self.am_used():
			return
		self.cal_check_timer = gobject.timeout_add_seconds(60, self.check_calendar, None)
		return


				
	def __init__(self):
		self.config = "gcal"
		self.auth = {}
		
		self.cal_lock = threading.Lock()
	
		self.cal_check_timer = -1
		self.calendars = []
		
		GIcon.__init__(self)
