import googsystray
import gtk,gobject
import urllib
import urllib2

from xml.dom import minidom
from xml.etree import ElementTree as ET

import GMain
import GBase

class GContacts(GBase.GBase):

	def dumpit(self, node, depth=0):
		for i in range(depth):
			print "\t",
		print "<" + node.tag.encode("utf-8"),
		for i in node.attrib:
			print " " + i + " = \"" + node.attrib[i].encode("utf-8") + "\"",
		print ">",
		if node.text != None:
			print node.text.encode("utf-8")
		else:
			print ""
		
		for i in node.getchildren():
			self.dumpit(i, depth+1)
			
	def getContactsWithPhones(self):
		return self.phoneContacts
	

	def getEntry(self, node):
		title = ""
		id = ""
		phoneNumbers = []
		emailAddresses = []
		for i in node.getchildren():
			if i.tag == "{http://www.w3.org/2005/Atom}id":
				id = i.text[68:]
			if i.tag == "{http://www.w3.org/2005/Atom}title":
				title = i.text
			if i.tag == "{http://schemas.google.com/g/2005}phoneNumber":
				if i.attrib.get("rel") != None:
					type = i.attrib["rel"][33:]
				else:
					type = i.attrib["label"]
				if i.attrib.get("primary"):
					p = True
				else:
					p = False
					
				phoneNumbers.append({"primary":p, "type":type, "number":i.text})
			if i.tag == "{http://schemas.google.com/g/2005}email":
				if i.attrib.get("rel") != None:
					type = i.attrib["rel"][33:]
				else:
					type = i.attrib["label"]
				if i.attrib.get("primary"):
					p = True
				else:
					p = False
					
				emailAddresses.append({"primary":p, "type":type, "address":i.attrib["address"]})
				
		if title != None:
			if self.contacts.get(id) == None:
				self.contacts[id] = {}
			self.contacts[id]["title"] = title
			self.contacts[id]["phone"] = phoneNumbers
			self.contacts[id]["email"] = emailAddresses
			self.contacts[id]["id"] = id # yes, we need this
			

	def check_data(self):
		if self.account["name"] not in self.auth or self.auth[self.account["name"]] == None:
			self.get_auth(self.account, 'cp')
			
		headers = {"Authorization" : self.auth[self.account["name"]],
			   "GData-Version" : "3"}
		
		url = "http://www.google.com/m8/feeds/contacts/default/full?max-results=10000"
		if self.updatedTime != None:
			url += "&updated-min=" + self.updatedTime
			
		data = self.urlopen2(self.account, url, headers=headers)

		if data == None:
			return
			
		root = ET.XML(data)

		for i in root.getchildren():
			if i.tag == "{http://www.w3.org/2005/Atom}updated":
				self.updatedTime=i.text
			if i.tag == "{http://www.w3.org/2005/Atom}entry":
				self.getEntry(i)


		self.phoneContacts = []
		for i in self.contacts.items():
			if i[1]["phone"] == []:
				continue;
			inserted = False
			pos = 0
			for j in self.phoneContacts:
				if j["title"] > i[1]["title"]:
					inserted = True
					self.phoneContacts.insert(pos, i[1])
					break
				pos+=1
			if not inserted:
				self.phoneContacts.append(i[1])

		return True
		
	def set_account(self, acct):
		self.account = acct

	def stop(self):
		self.stop_timer()
		return

	def start(self):
		self.start_timer()

	def __init__ (self):
		GBase.GBase.__init__(self)
		# 15 minutes
		self.account = None
		self.timeout = 15*60000
		self.updatedTime = None
		self.contacts = {}
		self.phoneContacts = []
		self.config = "contacts"
		