import googsystray

import socket
import gobject
import GMain

# To be honest, I'd much rather have used some sort of shared-memory IPC
# as I imagine some Windows firewall software is probably going to screw
# this up.  But I don't want to maintain two different things for Windows
# and *nix support.


class GIPC:
	def client_recv(self, source, cond):
		try:
			msg = source.recv(512)
			if len(msg) == 0:
				for i in self.clients:
					if i["socket"] == source:
						gobject.source_remove(i["gid"])
						self.clients.remove(i)
						return True
				print "Shouldn't get here"
				return True
			if msg == "CFG":
				gobject.idle_add(GMain._GConf.open_config_window, None)
			elif msg[:5] == "MAIL:":
				print "Mail: " + msg[5:]
				gobject.idle_add(GMain._GMail.parse_mailto, msg[5:])
				
		except socket.error, e:
			pass
		return True
			
	def server_connect(self, source, cond):
		try:
			(clientsocket, address) = self.serversocket.accept()
			gid = gobject.io_add_watch(clientsocket, gobject.IO_IN, self.client_recv)
			self.clients.append({"gid":gid,"socket":clientsocket})
		except:
			pass
		return True
	

	def start_server (self):
		self.serversocket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		self.serversocket.bind(('127.0.0.1', 49815))
		self.serversocket.listen(5)
		self.server_gid = gobject.io_add_watch(self.serversocket, gobject.IO_IN, self.server_connect)
		
		
	def start_client (self):
		try:
			self.clientsocket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
			self.clientsocket.connect(('127.0.0.1', 49815))
		except:
			self.clientsocket = None

	def is_client(self):
		if self.clientsocket == None:
			return False
		return True
		
	def start_config (self):
		self.clientsocket.send("CFG")
		
	def send_mail (self, mailto):
		self.clientsocket.send("MAIL:"+mailto)

	def __init__ (self):
		self.clientsocket = None
		self.serversocket = None
		self.clients = []
