import googsystray
import gtk,gobject
import webbrowser
import urlparse
import urllib
import copy
import threading
import gettext

from struct import *

import GIcon, GMain, GConf


from xml.etree import ElementTree as ET
		
	

class GMail(GIcon.GIcon):
	def label_clicked(self, widget, event, data=None):
		label = widget.get_child()
		message = widget.get_data("thr_data")

		for i in GMain._accounts:
			if i["name"] == message["account"]:
				account = i
				break

		if account["type"] == "Apps":
			base_url = "https://mail.google.com/a/" + account["domain"]
		else:
			base_url = "https://mail.google.com/mail"
			
		thr_id = message["data"]["thr_id"]


		if data == "markread":
			label.set_markup("<span color=\"#0000FF\" underline=\"single\">" + (_("Marking...")) + "</span>")
			self.send_post_mark(account, base_url + "/m/543241/?p=1.1&t=" + thr_id + "&bu=rd&at=" + account["gmail_at"], message)
			widget.set_sensitive(False)
		elif data == "markspam":
			label.set_markup("<span color=\"#0000FF\" underline=\"single\">" + (_("Marking...")) + "</span>")
			self.send_post_mark(account, base_url + "/m/543241/?p=1.1&t=" + thr_id + "&bu=sp&at=" + account["gmail_at"], message)
			widget.set_sensitive(False)
		elif data == "trash":
			label.set_markup("<span color=\"#0000FF\" underline=\"single\">" + (_("Deleting...")) + "</span>")
			self.send_post_mark(account, base_url + "/m/543241/?p=1.1&t=" + thr_id + "&bu=tr&at=" + account["gmail_at"], message)
			widget.set_sensitive(False)
		elif data == "archive":
			label.set_markup("<span color=\"#0000FF\" underline=\"single\">" + (_("Archiving...")) + "</span>")
			self.send_post_mark(account, base_url + "/m/543241/?p=1.1&t=" + thr_id + "&bu=ar&at=" + account["gmail_at"], message)
			widget.set_sensitive(False)
		elif data == "open":
			self.browser_open(base_url + "/?shva=1#label/" + self.fix_label_name(message["data"]["label"]) + "/" + thr_id)
			self.thread_lock.acquire()
			for i in self.messages_unread:
				if i["id"] == message["id"]:
					i["marked"] = True
					break
			self.thread_lock.release()
			gobject.idle_add(self.update_icon, None)

			
	
		return

	def label_enter(self, widget, data=None):
		cursor = gtk.gdk.Cursor(widget.get_display(), gtk.gdk.HAND2)
		window = widget.window
		window.set_cursor(cursor)

	def label_leave(self, widget, data=None):
		window = widget.window
		window.set_cursor(None)
		
	


	def draw_message(self, message):
		mvbox = self.popup_window.vbox
		
		vbox = gtk.VBox()
		mvbox.pack_start(vbox, False, False, 0)
		vbox.set_data("msg_id", message["id"])
		self.popup_messages.append(vbox)

		sep = gtk.HSeparator()
		vbox.pack_start(sep, False, False, 3)

		if self.num_used() > 1:
			labelname = message["account"] + " - " + message["data"]["label"]
		else:
			labelname = message["data"]["label"]

		fromt_label = gtk.Label()
		fromt_label.set_markup("<b>" + _("From:") + "</b>")
		subjt_label = gtk.Label()
		subjt_label.set_markup("<b>" + _("Subject:") + "</b>")
		from_label = gtk.Label(message["data"]["from"])
		subj_label = gtk.Label(message["data"]["subj"])
		time_label = gtk.Label()
		time_label.set_markup("  <span color=\"#404040\">" + message["data"]["time"] + "</span>")
		label_label = gtk.Label()
		label_label.set_markup("<span color=\"#404040\"><i>(" + labelname + ")</i></span>")
		ebox1 = gtk.EventBox()
		ebox1.set_events(gtk.gdk.BUTTON_PRESS_MASK |
				  gtk.gdk.ENTER_NOTIFY_MASK |
				  gtk.gdk.LEAVE_NOTIFY_MASK)
		ebox1.set_visible_window(False)
		ebox1.connect("button_press_event", self.label_clicked, "open")
		ebox1.connect("enter_notify_event", self.label_enter)
		ebox1.connect("leave_notify_event", self.label_leave)
		ebox1.set_data("thr_data", copy.deepcopy(message))
		ebox2 = gtk.EventBox()
		ebox2.set_events(gtk.gdk.BUTTON_PRESS_MASK |
				  gtk.gdk.ENTER_NOTIFY_MASK |
				  gtk.gdk.LEAVE_NOTIFY_MASK)

		ebox2.set_visible_window(False)
		ebox2.connect("button_press_event", self.label_clicked, "open")
		ebox2.connect("enter_notify_event", self.label_enter)
		ebox2.connect("leave_notify_event", self.label_leave)
		ebox2.set_data("thr_data", copy.deepcopy(message))

		hbox1 = gtk.HBox()
		ebox1.add(hbox1)
		hbox2 = gtk.HBox()
		ebox2.add(hbox2)
		hbox3 = gtk.HBox()
		vbox.pack_start(ebox1, False, False, 2)
		vbox.pack_start(ebox2, False, False, 2)
		vbox.pack_start(hbox3, False, False, 5)
		
		hbox1.pack_start(fromt_label, False, False, 2)
		hbox1.pack_start(from_label, False, False, 2)
		hbox1.pack_start(time_label, False, False, 2)
		hbox1.pack_end(label_label, False, False, 2)
		hbox2.pack_start(subjt_label, False, False, 5)
		hbox2.pack_start(subj_label, False, False, 2)


		button=GIcon.link_label()
		button.set_markup("<span color=\"#0000FF\" underline=\"single\">" + (_("Delete")) + "</span>")
		button.connect("button_press_event", self.label_clicked, "trash")
		button.set_data("thr_data", copy.deepcopy(message))
		hbox3.pack_end(button, True, True, 10)

		button=GIcon.link_label()
		button.set_markup("<span color=\"#0000FF\" underline=\"single\">" + (_("Archive")) + "</span>")
		button.connect("button_press_event", self.label_clicked, "archive")
		button.set_data("thr_data", copy.deepcopy(message))
		hbox3.pack_end(button, True, True, 10)

		button=GIcon.link_label()
		button.set_markup("<span color=\"#0000FF\" underline=\"single\">" + (_("Mark as read")) + "</span>")
		button.connect("button_press_event", self.label_clicked, "markread")
		button.set_data("thr_data", copy.deepcopy(message))
		hbox3.pack_end(button, True, True, 10)

		button=GIcon.link_label()
		button.set_markup("<span color=\"#0000FF\" underline=\"single\">" + (_("Mark as spam")) + "</span>")
		button.connect("button_press_event", self.label_clicked, "markspam")
		button.set_data("thr_data", copy.deepcopy(message))
		
		hbox3.pack_end(button, True, True, 10)
		vbox.show_all()
		
	def make_new_label(self, account, label_str, hidden):
		label_str2 = urllib.quote(label_str, "")
		
		for i in self.get_config()["sub_notifications"]:
			if i["name"] == label_str and i["account"] == account["name"]:
				return
				
		new_not = copy.deepcopy(GConf.default_gmail_notification)
		new_not["account"] = account["name"]
		new_not["hidden"] = hidden
		new_not["webname"] = label_str2
		new_not["name"] = label_str
		self.get_config()["sub_notifications"].append(new_not)
			
		GMain._GConf.save_config()


	def dumpit(self, node, depth=0):
		for i in range(depth):
			print "  ",
		print "<" + node.tag.encode("utf-8"),
		for i in node.attrib:
			print " " + i + " = \"" + node.attrib[i].encode("utf-8") + "\"",
		print ">",
		if node.text != None:
			print node.text.encode("utf-8")
		else:
			print ""
		
		for i in node.getchildren():
			self.dumpit(i, depth+1)
		
	def get_string(self, i, data):
                # it seems an error can occur here that I'm not sure
                # exactly how it happens.  short data from google,
                # but we need to handle it FIXME
		len = 0
		(len,) = unpack('!H', data[i:i+2])
		i += 2
		str = data[i:i+len]
		i += len
		return (i, str)


	# Is this the only one?  I'm not sure...  Apparently with the mobile
	# API it doesn't want /'s replaced with %2F.  I'm sure other special
	# chars will cause problems as well.  
	def fix_label_name(self, label):
		return label.replace("/", "-")

	def compose_email(self, to=None, cc=None, bcc=None, subj=None, body=None):
		url = self.base_url + "?view=cm&tf=0"
		if to != None:
			url = url + "&to=" + to 
		if cc != None:
			url = url + "&cc=" + cc
		if bcc != None:
			url = url + "&bcc=" + bcc 
		if subj != None:
			url = url + "&su=" + subj
		if body != None:
			url = url + "&body=" + body 
		webbrowser.open(url, 1)
		# fixme, this needs to be configurable
		
	def parse_mailto(self, mailto):
		to=""
		cc=None
		bcc=None
		subj=None
		body=None
		if mailto[:6] == "inbox:":
			webbrowser.open("https://mail.google.com")
			return
		if mailto[:7] == "mailto:":
			mailto=mailto[7:]
		c = mailto.find("?")
		if c == -1:
			to = mailto
		else:
			to = mailto[:c]
			o = urlparse.parse_qsl(mailto[c+1:])
			for i in o:
				(key, val) = i
				if key == "subject":
					subj = val
				elif key == "body":
					body = val
				elif key == "cc":
					cc = val
				elif key == "bcc":
					bcc = val
		self.compose_email(to, cc, bcc, subj, body)
			
	def icon_check_data(self, account):
		new_messages = []
		
		if account["type"] == "Apps":
			base_url = "https://mail.google.com/a/" + account["domain"]
		else:
			base_url = "https://mail.google.com/mail"

		if not account["name"] in self.got_cookies or not self.got_cookies[account["name"]]:
			data = self.urlopen2(account, base_url + "/x/432141/&s=l&l=Inbox")
			self.got_cookies[account["name"]] = False
			for i in account["cproc"].cookiejar:
				if i.name == "GMAIL_AT":
					account["gmail_at"] = i.value
					self.got_cookies[account["name"]] = True
			if not self.got_cookies[account["name"]]:
				print "Error on " + account["name"]
					
		for i in self.get_config()["sub_notifications"]:
			if i["account"] != account["name"]:
				continue
			if i["hidden"]:
				continue
			o = 0
			fname = self.fix_label_name(i["name"])
			
			urlstr = base_url + "/m/5435345/?p=1.1&s=q&q=L:" + fname
			data = self.urlopen2(account, urlstr)
			
			if data == None:
				continue


			c = 0;
			(c, status) = self.get_string(c, data)
			if status != "T":
				continue
			# fixme status should be 'T', do error checking
			(c, id_code) = self.get_string(c, data)
			(c, st_thread) = self.get_string(c, data)
			(c, num_threads) = self.get_string(c, data)
			(c, tot_threads) = self.get_string(c, data)
			(c, num_unread) = self.get_string(c, data)
			for j in range(int(num_threads)):
				(c, is_read_str) = self.get_string(c, data)
				(c, is_starred_str) = self.get_string(c, data)
				(c, has_attachments_str) = self.get_string(c, data)
				(c, from_str) = self.get_string(c, data)
				(c, subject_str) = self.get_string(c, data)
				(c, time_str) = self.get_string(c, data)
				(c, url_str) = self.get_string(c, data)

				if is_read_str == "F":
					new_messages.append(
						{ "id": url_str + from_str + time_str,
						  "sub_id": i["webname"],
						  "account": account["name"],
						  "count": 1,
						  "title": from_str, # Fixme, needs to include [account] + label
						  "summary": subject_str,
						  "icon": None,
						  "marked": False,
						  "data": { "label" : i["name"],
						  	    "from"  : from_str,
						  	    "subj"  : subject_str,
						  	    "time"  : time_str,
						  	    "thr_id": url_str[4:],
						  	  }
						})
					o += 1
								    
			(c, num_labels) = self.get_string(c, data)
			for j in range(int(num_labels)):
				(c, label_str) = self.get_string(c, data)
				(c, num_unread_str) = self.get_string(c, data)
				self.make_new_label(account, label_str, True)

		self.merge_messages(account["name"], new_messages)
		return True

	def make_tooltip(self):
		lcnt = {}		
		for i in self.messages_unread:
			if not i["marked"]:
				if self.num_used() == 1:
					tmp = i["data"]["label"]
				else:
					tmp = i["account"]
					
				if tmp in lcnt:
					lcnt[tmp] += 1
				else:
					lcnt[tmp] = 1
		tmp = ""
		for i in lcnt.items():
			if tmp != "":
				tmp += "\n"
			tmp += i[0]
			tmp += ": " + str(i[1])
		if tmp == "":
			return _("No new emails.")
		return tmp


        def mark_all_read(self, widget, data=None):
        	self.thread_lock.acquire()
        	
        	for m in self.messages_unread:
			for i in GMain._accounts:
				if i["name"] == m["account"]:
					account = i
					break

			if account["type"] == "Apps":
				base_url = "https://mail.google.com/a/" + account["domain"]
			else:
				base_url = "https://mail.google.com/mail"
			
			thr_id = m["data"]["thr_id"]

			self.send_post_mark(account, base_url + "/m/543241/?p=1.1&t=" + thr_id + "&bu=rd&at=" + account["gmail_at"], m)
		self.thread_lock.release()
        	


	def add_menu_items(self):
		menuItem = gtk.MenuItem(_("Mark all Read"))

		menuItem.connect("activate", self.mark_all_read)
		self.menu.append(menuItem)

	def icon_stop(self):
		self.unbind_hotkey("open_gmail")
#		self.unbind_hotkey("compose_email")

	def icon_start(self):
		self.got_cookies = {}
		self.bind_hotkey("open_gmail", self.browser_open, self.url)
#		self.bind_hotkey("compose_email", self.browser_open, )


	def __init__(self):
		self.got_cookies = {}
		self.gmail_at = {}
		self.config = "gmail"
		
		GIcon.GIcon.__init__(self)
	

