import os
import gettext
import locale
#########################################################
# Config
#########################################################

VERSION_MAJOR = 1
VERSION_MINOR = 1
VERSION_REV   = 4
VERSION_STRING = str(VERSION_MAJOR) + "." + str(VERSION_MINOR) + "." + str(VERSION_REV)

DEFAULT_TIMEOUT = 180000

#class ConfigWindow:

ONCLICK_NOACTION = -1
ONCLICK_OPEN = 0
ONCLICK_NEW_WINDOW = 1
ONCLICK_NEW_TAB = 2
ONCLICK_OTHER = 3


if (os.name == "posix"):
	temp_dir = "/tmp/googsystray-" + os.getenv("USER") + "/"
	if not os.path.exists(temp_dir):
		os.makedirs(temp_dir)

	config_dir = os.getenv("HOME")
	config_name = ".googsystrayrc"
elif (os.name == "nt"):
	config_dir = os.getenv("APPDATA")
	print config_dir
	temp_dir = os.getenv("TEMP")
	config_name = "googsystray.ini"
else:
	print "Error: Unable to locate temp directory for " + os.name




BASE_DIR = "/tmp"



def set_basedir(bdir):
	global BASE_DIR
	BASE_DIR=bdir
	locale.setlocale(locale.LC_ALL, "")
	(lang_str,cp) = locale.getlocale()
	if os.name == "nt":
                # Oh, damn you windows.  We'll need to add here for any
                # language we wish to support.
                (language, sep, country) = lang_str.partition("_")
                new_country = None
                new_language = "en" # We'll just default to English.

                # This set is important for translations
                if language == "Chinese (Simplified)":
                        new_language = "zh"
                elif language == "English":
                        new_language = "en"
                elif language == "French":
                        new_language = "fr"
                elif language == "German":
                        new_language = "de"
                elif language == "Italian":
                        new_language = "it"
                elif language == "Japanese":
                        new_language = "ja"
                elif language == "Russian":
                        new_language = "ru"
                elif language == "Spanish":
                        new_language = "es"
                else:
                        print "Unrecognized lang: " + language

                # This set is important for dates/times/etc
                if country == "Australia":
                        new_country = "AU"
                elif country == "Canada":
                        new_country = "CA"
                elif country == "France":
                        new_country = "FR"
                elif country == "Germany":
                        new_country = "DE"
                elif country == "Japan":
                        new_country = "JA" # ???
                elif country == "People's Republic of China":
                        new_country = "CN"
                elif country == "Russia":
                        new_country = "RU"
                elif country == "United Kingson":
                        new_country = "UK"
                elif country == "United States":
                        new_country = "US"
                else:
                        print "Unrecognized country: " + country


                if new_country is None:
                        os.environ['LANG'] = new_language
                else:
                        os.environ['LANG'] = new_language + "_" + new_country

	if gettext.find("googsystray", os.path.join(BASE_DIR, "po")) == None:
                # This should only get called on a Linux install, where the
                # .mo files are installed to a system locale directory.
                # However, we will also get here on a Windows system where
                # we do not have proper translations (Or English)
                
                
		gettext.install("googsystray")
	else:
		gettext.install("googsystray", os.path.join(BASE_DIR, "po"))
		

def get_basedir():
	return os.path.dirname(__file__)
